﻿//
// MainPage.xaml.cpp
// Implementation of the MainPage class.
//

#include "pch.h"
#include "MainPage.xaml.h"

using namespace CPlusPlusThumbnails;

using namespace Platform;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::UI::Xaml;
using namespace Windows::UI::Xaml::Controls;
using namespace Windows::UI::Xaml::Controls::Primitives;
using namespace Windows::UI::Xaml::Data;
using namespace Windows::UI::Xaml::Input;
using namespace Windows::UI::Xaml::Media;
using namespace Windows::UI::Xaml::Navigation;
using namespace Windows::Storage::Pickers;
using namespace Windows::UI::Xaml::Media::Imaging;
using namespace Windows::Storage::Streams;
using namespace Windows::Storage;
using namespace ThumbnailLibrary;
using namespace concurrency;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

MainPage::MainPage()
{
	InitializeComponent();
}

/// <summary>
/// Invoked when this page is about to be displayed in a Frame.
/// </summary>
/// <param name="e">Event data that describes how this page was reached.  The Parameter
/// property is typically used to configure the page.</param>
void MainPage::OnNavigatedTo(NavigationEventArgs^ e)
{
	(void) e;	// Unused parameter
}

Windows::UI::Xaml::Media::Imaging::WriteableBitmap^ MainPage::LoadBitmap(IRandomAccessStream^ stream)
{
	WriteableBitmap^ bitmap = ref new WriteableBitmap(1,1);
	bitmap->SetSource(stream);
	bitmap->Invalidate();
	return bitmap;
}

void CPlusPlusThumbnails::MainPage::Button_Click_1(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ e)
{
	FileOpenPicker^ openPicker = ref new FileOpenPicker();
	openPicker->ViewMode = PickerViewMode::Thumbnail;
	openPicker->SuggestedStartLocation = PickerLocationId::PicturesLibrary;
	openPicker->FileTypeFilter->Append(".jpg");
	openPicker->FileTypeFilter->Append(".jpeg");
	openPicker->FileTypeFilter->Append(".png");

	create_task(openPicker->PickSingleFileAsync()).then([this](StorageFile^ file)
	{
		if (file)
		{
			create_task(file->OpenReadAsync()).then([this,file](IRandomAccessStream^ stream)
			{
				SourceImage->Source = this->LoadBitmap(stream);
				ThumbnailMaker^ maker = ref new ThumbnailMaker();
				create_task(maker->GenerateThumbnailAsync(file)).then([this](Uri^ uri)
				{
					RandomAccessStreamReference^ thumbnailStream = RandomAccessStreamReference::CreateFromUri(uri);
					create_task(thumbnailStream->OpenReadAsync()).then([this](IRandomAccessStream^ imageStream) {
						auto image = ref new BitmapImage();					
						image->SetSource((IRandomAccessStream^)imageStream);
						ThumbnailImage->Source = image;
					});
				});
			});			
		}
		else
		{
			auto dialog = ref new Windows::UI::Popups::MessageDialog("No image was selected.");
			dialog->ShowAsync();
		}
	});
}
