﻿// For an introduction to the Blank template, see the following documentation:
// http://go.microsoft.com/fwlink/?LinkId=232509
(function () {
    "use strict";

    var app = WinJS.Application;
    var activation = Windows.ApplicationModel.Activation;
    WinJS.strictProcessing();

    app.onactivated = function (args) {
        if (args.detail.kind === activation.ActivationKind.launch) {
            if (args.detail.previousExecutionState !== activation.ApplicationExecutionState.terminated) {
                // TODO: This application has been newly launched. Initialize
                // your application here.
            } else {
                // TODO: This application has been reactivated from suspension.
                // Restore application state here.
            }
            args.setPromise(WinJS.UI.processAll());
            document.getElementById("pick").addEventListener("click", pickSingleImage, false);
        }
    };

    app.oncheckpoint = function (args) {
        // TODO: This application is about to be suspended. Save any state
        // that needs to persist across suspensions here. You might use the
        // WinJS.Application.sessionState object, which is automatically
        // saved and restored across suspension. If you need to complete an
        // asynchronous operation before your application is suspended, call
        // args.setPromise().
    };
    
    function pickSingleImage() {
        var openPicker = new Windows.Storage.Pickers.FileOpenPicker();
        openPicker.viewMode = Windows.Storage.Pickers.PickerViewMode.thumbnail;
        openPicker.suggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.picturesLibrary;
        openPicker.fileTypeFilter.replaceAll([".png", ".jpg", ".jpeg"]);
openPicker.pickSingleFileAsync().then(function (file) {
            if (file) {
                // Application now has read/write access to the picked file 
                var url = URL.createObjectURL(file);
                var src = document.getElementById("sourceImage");
                src.src = url;
                src.alt = file.displayName;
                var thumb = new ThumbnailLibrary.ThumbnailMaker();
                thumb.generateThumbnailAsync(file).then(function (fileUrl) {
                    var thumbImage = document.getElementById("thumbnail");
                    thumbImage.src = fileUrl.rawUri;
                    thumbImage.alt = thumbImage.src;
                });
            } else {
                // The picker was dismissed with no selected file 
                var dlg = new Windows.UI.Popups.MessageDialog("No image was selected.");
                dlg.showAsync();
            }
        });

    }
    

    app.start();
})();
