Imports ThumbnailLibrary
Imports Windows.Storage.Pickers
Imports Windows.Storage.Streams
Imports Windows.UI.Popups
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Media.Imaging
Imports Windows.UI.Xaml.Navigation

' The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

''' <summary>
''' An empty page that can be used on its own or navigated to within a Frame.
''' </summary>
Partial Public NotInheritable Class MainPage
    Private Shared Function LoadBitmap(ByVal stream As IRandomAccessStream) As WriteableBitmap
        Dim bitmap As WriteableBitmap = New WriteableBitmap(1, 1)
        bitmap.SetSource(stream)
        bitmap.Invalidate()
        Return bitmap
    End Function

    Public Sub New()
        InitializeComponent()
    End Sub

    ''' <summary>
    ''' Invoked when this page is about to be displayed in a Frame.
    ''' </summary>
    ''' <param name="e">Event data that describes how this page was reached.  The Parameter
    ''' property is typically used to configure the page.</param>
    Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
    End Sub

    Private Async Sub Button_Click_1(ByVal sender As Object, ByVal e As RoutedEventArgs)
        Dim openPicker As FileOpenPicker = New FileOpenPicker With {.ViewMode = PickerViewMode.Thumbnail, .SuggestedStartLocation = PickerLocationId.PicturesLibrary}
        openPicker.FileTypeFilter.Add(".jpg")
        openPicker.FileTypeFilter.Add(".jpeg")
        openPicker.FileTypeFilter.Add(".png")

        Dim file As Windows.Storage.StorageFile = Await openPicker.PickSingleFileAsync

        If file Is Nothing Then
            Dim dialog As MessageDialog = New MessageDialog("No image was selected.")
            Await dialog.ShowAsync
            Exit Sub
        End If

        Using fileStream As IRandomAccessStreamWithContentType = Await file.OpenReadAsync
            SourceImage.Source = LoadBitmap(fileStream)
            Dim maker As ThumbnailMaker = New ThumbnailMaker
            Dim stream As RandomAccessStreamReference = RandomAccessStreamReference.CreateFromUri(Await maker.GenerateThumbnailAsync(file))
            Dim bitmapImage As BitmapImage = New BitmapImage
            bitmapImage.SetSource(Await stream.OpenReadAsync)
            ThumbnailImage.Source = bitmapImage
        End Using
    End Sub
End Class
